#include <bits/stdc++.h>
#define str string
using namespace std;
int n,m,k,x;
str s,s1,s2;
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    freopen("FWORD.INP","r",stdin);
    freopen("FWORD.OUT","w",stdout);
    cin>>n>>m>>k>>x;
    cin>>s;
    cin>>s1;
    sort(s1.begin(),s1.end());
    for(int i=0;i<s.size();i++)
    {
        if(s[i]=='#')
            cout<<s1[x-1];
        else
            cout<<s[i];
    }
    return 0;
}
